#include <windows.h>
#include "resource.h"

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam);

void Gotcha(void);
BOOL CALLBACK EnumWindowsProc(HWND hWnd,LPARAM lParam);
BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam);

HINSTANCE hInst;
HWND hWnd;
HWND hEdit;

BYTE buf[65535];
char pwds[65535];

char strMyUnHide[] = "MyUnHide Copyright  2002 Cyrill Tkachenko";

int STDCALL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {

	WNDCLASS wndClass;
	MSG msg;

	hInst = GetModuleHandle(NULL);

	wndClass.style = CS_HREDRAW | CS_VREDRAW;
	wndClass.lpfnWndProc = WndProc;
	wndClass.cbClsExtra = (int)NULL;
	wndClass.cbWndExtra = (int)NULL;
	wndClass.hInstance = hInst;
	wndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndClass.hCursor = NULL;
	wndClass.hbrBackground = (struct HBRUSH__ *)GetStockObject(LTGRAY_BRUSH);
	wndClass.lpszMenuName = MAKEINTRESOURCE(MENU1);
	wndClass.lpszClassName = "MyUnHideClass";
	RegisterClass(&wndClass);

	hWnd = CreateWindow("MyUnHideClass",strMyUnHide,
		WS_OVERLAPPEDWINDOW,
		0,0,600,500,NULL,NULL,hInst,NULL);

	hEdit = CreateWindowEx(0,"EDIT","",
		WS_VISIBLE|WS_CHILD|ES_MULTILINE|WS_VSCROLL|WS_HSCROLL|WS_TABSTOP|ES_LEFT|ES_AUTOVSCROLL|ES_WANTRETURN,
		0,0,0,0,hWnd,0,hInst,0);

	Gotcha();

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, (int)NULL, (int)NULL)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		};

	return 0;

}

LRESULT APIENTRY WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	switch(message) {

	case WM_COMMAND:
		return PerformMenuCommand(hWnd, wParam);

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;

	case WM_SIZE:
		MoveWindow(hEdit,0,0,LOWORD(lParam),HIWORD(lParam),TRUE);
		return 0;
	};

	return DefWindowProc(hWnd, message, wParam, lParam);
}

LRESULT PerformMenuCommand(HWND hWnd, WPARAM wParam) {

	switch(LOWORD(wParam)) {

	case ID_FILE_EXIT:
		PostQuitMessage(0);
		break;

	case ID_FILE_UPDATE:
		Gotcha();
		break;

	case ID_HELP_ABOUT:
		MessageBox(hWnd,strMyUnHide,strMyUnHide,0);
		break;

	};

	return 0;
}

void Gotcha(void) {
	ZeroMemory((char *)pwds,65535);
	EnumWindows(&EnumWindowsProc,0);
	SetWindowText(hEdit,(char *)pwds);
}

BOOL CALLBACK EnumWindowsProc(HWND hWnd,LPARAM lParam) {
	EnumChildWindows(hWnd,&EnumChildProc,lParam);
	return TRUE;
}

BOOL CALLBACK EnumChildProc(HWND hWnd,LPARAM lParam) {
	if (SendMessage(hWnd,EM_GETPASSWORDCHAR,0,0)!=0) {
		SendMessage(hWnd,WM_GETTEXT,65535,(LPARAM)buf);
		lstrcat((char *)buf,"\r\n\0");
		lstrcat((char *)pwds,(char *)buf);
	};
	return TRUE;
}
